package com.example.exvesta.Screans

import android.content.Context
import android.util.Log
import androidx.compose.foundation.BorderStroke
import androidx.compose.foundation.Image
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxHeight
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.offset
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.CircleShape
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material3.Button
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material.DrawerValue
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.Text
import androidx.compose.material3.rememberDrawerState
import androidx.compose.runtime.Composable
import androidx.compose.runtime.rememberCoroutineScope
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.clip
import androidx.compose.ui.draw.shadow
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.unit.dp
import androidx.navigation.NavHostController

//noinspection UsingMaterialAndMaterial3Libraries
import androidx.compose.material.*
import androidx.compose.runtime.*

import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.LazyRow
import androidx.compose.foundation.lazy.items
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.Menu
import androidx.compose.ui.graphics.Brush
import androidx.compose.ui.layout.ContentScale
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.unit.sp
import coil.compose.AsyncImagePainter
import coil.compose.rememberAsyncImagePainter
import coil.request.ImageRequest
import coil.size.Size
import com.example.exvesta.domain.utils.Constants
import com.example.exvesta.model.Consists_wardrob
import com.example.exvesta.model.Publicthings
import com.example.exvesta.model.Season
import com.example.exvesta.model.Season_dublicate
import com.example.exvesta.model.Style
import com.example.exvesta.model.Style_dublicate
import com.example.exvesta.model.Things_user
import com.example.exvesta.model.Type
import com.example.exvesta.model.Type_dublicate
import com.example.exvesta.model.Type_subtype
import com.example.exvesta.model.Type_subtype_dublicate
import com.example.exvesta.model.Users
import com.example.exvesta.model.Wardob
import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import kotlinx.coroutines.withContext
import androidx.appcompat.app.AlertDialog
import androidx.compose.ui.tooling.preview.Preview

@Composable
fun Wardrob(navHost: NavHostController) {
    var drawerState = rememberDrawerState(DrawerValue.Closed)
    val scope = rememberCoroutineScope()
    var isFiltersVisible by remember { mutableStateOf(false) }
    var filteredPublicThings by remember { mutableStateOf<List<Consists_wardrob>>(listOf()) }
    var subdubtype by remember { mutableStateOf<List<Type_subtype>>(listOf()) }
    var types by remember { mutableStateOf<List<Type>>(listOf()) }
    var season by remember { mutableStateOf<List<Season>>(listOf()) }
    var userthings by remember { mutableStateOf<List<Things_user>>(listOf()) }
    var style by remember { mutableStateOf<List<Style>>(listOf()) }
    var filtersApplied by remember { mutableStateOf(false) }
    var isFilterSheetVisible by remember { mutableStateOf(false) }
    var wardrobs by remember { mutableStateOf<List<Wardob>>(listOf()) }
    var cwardrobs by remember { mutableStateOf<List<Consists_wardrob>>(listOf()) }
    var users by remember { mutableStateOf<List<Users>>(listOf()) }
    val context = LocalContext.current // Получение контекста
    val coroutineScope = rememberCoroutineScope() // Создание корутинного скоупа
    var openDialog by remember { mutableStateOf(false) }
    var itemToDelete by remember { mutableStateOf<Consists_wardrob?>(null) }

    val viewModel = Auth()
    LaunchedEffect(Unit) {
        withContext(Dispatchers.IO) {
            userthings  = Constants.supabase.from("Things_user")
                .select().decodeList<Things_user>()
            wardrobs  = Constants.supabase.from("Wardob")
                .select().decodeList<Wardob>()
            cwardrobs  = Constants.supabase.from("Consists_wardrob")
                .select().decodeList<Consists_wardrob>()
            subdubtype = Constants.supabase.from("Type_subtype")
                .select().decodeList<Type_subtype>()
            types = Constants.supabase.from("Type")
                .select().decodeList<Type>()
            season = Constants.supabase.from("Season")
                .select().decodeList<Season>()
            style = Constants.supabase.from("Style")
                .select().decodeList<Style>()
            users = Constants.supabase.from("Users")
                .select().decodeList<Users>()
//            cwardrobs.forEach { it ->
//                Log.d("ts", it.toString())
            }
        }
        filteredPublicThings = cwardrobs
//    DeleteConfirmationDialog(
//        openDialog = openDialog,
//        userthing = itemToDelete!!, // Убедитесь, что itemToDelete не null
//        onConfirm = { item ->
//            item?.let {
//                viewModel.deleteItem(it) // Вызов функции удаления из ViewModel
//                openDialog = false // Закрыть диалог
//                itemToDelete = null // Сбросить элемент после удаления
//            }
//        },
//        onDismiss = {
//            openDialog = false
//            itemToDelete = null // Сбросить элемент после закрытия диалога
//        }
//            )
    ModalDrawer(
        drawerState = drawerState,
        drawerContent = {
            DrawerContent(navHost)
        },
    ) {
        Column(
            modifier = Modifier
                .fillMaxSize()
                .background(Color.White)
                .padding(16.dp),
            horizontalAlignment = Alignment.CenterHorizontally
        ) {
            Row(
                modifier = Modifier
                    .fillMaxWidth()
                    .padding(vertical = 16.dp),
                verticalAlignment = Alignment.CenterVertically,
                horizontalArrangement = Arrangement.Start
            ) {
                IconButton(onClick = {
                    scope.launch { drawerState.open() }
                }) {
                    Icon(imageVector = Icons.Filled.Menu, contentDescription = "Menu")
                }


                Column(){
                    Button(
                        onClick = {

                            scope.launch { drawerState.close() } // Закрываем drawer
                        },
                        border = BorderStroke(1.dp, Color(0xFF92A2B0)),
                        modifier = Modifier
                            .fillMaxWidth()
                            .padding(vertical = 8.dp),
                        colors = ButtonDefaults.buttonColors(Color.White)
                    ) {
                        Text(text = "+ добавить фильтр", color = Color(0xFF92A2B0))
                    }


                    Button(
                        onClick = { /*TODO*/ },
                        border = BorderStroke(1.dp, Color(0xFF92A2B0)),
                        modifier = Modifier
                            .fillMaxWidth()
                            .padding(vertical = 8.dp),
                        colors = ButtonDefaults.buttonColors(Color.White)
                    ) {
                        Text(text = "+ добавить вещь", color = Color(0xFF92A2B0))
                    }

                }
            }
            if (filtersApplied) {
                Button(
                    onClick = {
                        filteredPublicThings = cwardrobs
                        filtersApplied = false
                    },
                    border = BorderStroke(1.dp, Color(0xFF92A2B0)),
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(vertical = 8.dp),
                    colors = ButtonDefaults.buttonColors(Color(0xFFF1F1F3))
                ) {
                    Text(text = "сбросить фильтры", color = Color(0xFF92A2B0))
                }
            }






            Spacer(modifier = Modifier.height(10.dp))
            val userId = Constants.supabase.auth.currentUserOrNull()?.id
            val authorizedUser  = users.find { it.user == userId }

            if (authorizedUser  != null) {
                // Group items by type
                val itemsByType = filteredPublicThings.groupBy { userthing ->
                    val thing = userthings.find { it.id == userthing.id_thing }
                    thing?.subtype?.let { subtype ->
                        subdubtype.find { it.id == subtype }?.id_type
                    }
                }

                LazyColumn(modifier = Modifier.fillMaxSize().padding(10.dp)) {
                    items(types) { type ->
                        val typeItems = itemsByType[type.id] ?: emptyList()

                        if (typeItems.isNotEmpty()) {
                            Text(
                                text = type.title_type,

                                modifier = Modifier.padding(8.dp)
                            )

                            LazyRow {
                                items(typeItems) { userthing ->
                                    val thing = userthings.find { it.id == userthing.id_thing }
                                    if (thing != null) {
                                        val imageState = rememberAsyncImagePainter(
                                            model = ImageRequest.Builder(LocalContext.current)
                                                .data(thing.img)
                                                .size(Size.ORIGINAL).build()
                                        ).state

                                        Card(
                                            modifier = Modifier
                                                .padding(8.dp)
                                                .width(330.dp)
                                                .shadow(8.dp, RoundedCornerShape(30.dp)),
                                            shape = RoundedCornerShape(30.dp),
                                            backgroundColor = Color.White
                                        ) {
                                            Column {
                                                if (imageState is AsyncImagePainter.State.Error) {
                                                    Box(
                                                        modifier = Modifier
                                                            .fillMaxWidth()
                                                            .height(250.dp),
                                                        contentAlignment = Alignment.Center
                                                    ) {
                                                        CircularProgressIndicator()
                                                    }
                                                }

                                                if (imageState is AsyncImagePainter.State.Success) {
                                                    Image(
                                                        modifier = Modifier
                                                            .fillMaxWidth()
                                                            .height(250.dp),
                                                        painter = imageState.painter,
                                                        contentDescription = "",
                                                        contentScale = ContentScale.Crop
                                                    )
                                                }

                                                Divider(
                                                    modifier = Modifier.padding(vertical = 8.dp),
                                                    color = Color.LightGray,
                                                    thickness = 1.dp
                                                )

                                                Text(
                                                    "Название: ${thing.title}",
                                                    fontSize = 18.sp,
                                                    modifier = Modifier.padding(start = 8.dp),
                                                    color = Color(0xFF92A2B0)
                                                )

                                                // Display categories
                                                val seasonid = thing.id_season
                                                val seasonItem = season.find { it.id == seasonid }
                                                val styleid = thing.style
                                                val styleItem = style.find { it.id == styleid }
                                                val subtypeid = thing.subtype
                                                val subtypeItem =
                                                    subdubtype.find { it.id == subtypeid }

                                                if (subtypeItem != null) {
                                                    val typeid = subtypeItem.id_type
                                                    val typeItem = types.find { it.id == typeid }
                                                    if (seasonItem != null && styleItem != null && typeItem != null) {
                                                        Text(
                                                            "Категории: ${styleItem.title_style}, ${typeItem.title_type}, ${subtypeItem.sub_type}, ${seasonItem.title_season}",
                                                            fontSize = 18.sp,
                                                            modifier = Modifier.padding(start = 8.dp),
                                                            color = Color(0xFF92A2B0)
                                                        )
                                                    }
                                                }


                                                Button(
                                                    onClick = {
                                                        itemToDelete = userthing
                                                        openDialog = true
                                                    },
                                                    modifier = Modifier
                                                        .padding(8.dp)
                                                        .align(Alignment.CenterHorizontally)
                                                ) {


                                                    Text("Удалить")
                                                }






                                            }
                                        }

                                    }

                                }

                            }


                        }
                    }

                }
                if (itemToDelete != null) {
                    DeleteConfirmationDialog(
                        openDialog = openDialog,
                        userthing = itemToDelete!!, // Уверены, что itemToDelete не null
                        onConfirm = { item ->
                            item?.let {
                                viewModel.deleteItem(it) // Вызов функции удаления из ViewModel
                            }
                            openDialog = false // Закрыть диалог
                            itemToDelete = null // Сбросить элемент после удаления
                        },
                        onDismiss = {
                            openDialog = false // Закрыть диалог при отмене
                            itemToDelete = null // Сбросить элемент после закрытия диалога
                        }
                    )
                }
            }

        }

    }
//    if (isFilterSheetVisible) {
//        Column {
//            Filters(
//                onApplyFilters = { selectedSubtype, selectedSeason, selectedStyle ->
//                    // Применяем фильтры и обновляем отображение
//                    filteredPublicThings = userthings.filter { userthing ->
//                        (selectedSubtype == null || userthing.subtype == selectedSubtype.id) &&
//                                (selectedSeason == null || userthing.id_season == selectedSeason.id)&&
//                                (selectedStyle == null || userthing.style == selectedStyle.id)
//                    }
//
//                    isFilterSheetVisible = false // Закрываем окно фильтров
//                    filtersApplied = true;
//                },
//                onDismiss = { isFilterSheetVisible = false })
//
//        }
//    }



}

@Composable
fun DeleteConfirmationDialog(
    openDialog: Boolean,
    userthing: Consists_wardrob,
    onConfirm: (Consists_wardrob) -> Unit,
    onDismiss: () -> Unit
) {
    if (openDialog) {
        AlertDialog(
            onDismissRequest = onDismiss,
            title = {
                Text(text = "Подтверждение удаления")
            },
            text = {
                Text("Вы уверены, что хотите удалить эту вещь?")
            },
            confirmButton = {
                Button(onClick = {
                    onConfirm(userthing) // Вызов функции для удаления элемента
                    onDismiss() // Закрыть диалог после подтверждения
                }) {
                    Text("Да")
                }
            },
            dismissButton = {
                Button(onClick = onDismiss) {
                    Text("Нет")
                }
            }
        )
    }
}


